package zero1hd.rhythmbullet.desktop.screens;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Screen;
import com.badlogic.gdx.ScreenAdapter;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;

import zero1hd.rhythmbullet.RhythmBullet;
import zero1hd.rhythmbullet.desktop.screens.main.MainScreen;
import zero1hd.rhythmbullet.util.InitialScreen;

public class SplashScreen extends ScreenAdapter implements InitialScreen {
	private Sprite splashSprite;
	private SpriteBatch batch;
	private Color color = new Color(1f, 1f, 1f, 1f);
	private float fadeTime = 1.5f;
	
	@Override
	public void init() {
		batch = new SpriteBatch();
		splashSprite = new Sprite(new Texture(Gdx.files.internal("splashlogo.png")));
		float scale = (Gdx.graphics.getHeight()/3f)/splashSprite.getHeight();
		splashSprite.setSize(scale*splashSprite.getWidth(), scale*splashSprite.getHeight());
		splashSprite.setPosition((Gdx.graphics.getWidth()-splashSprite.getWidth())/2f, (Gdx.graphics.getHeight()-splashSprite.getHeight())/2f);
	}
	
	@Override
	public void render(float delta) {
		Gdx.gl.glClearColor(1f, 1f, 1f, 1f);
		Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);
		batch.begin();
		float change = delta/fadeTime;
		color.a -= change;
		splashSprite.setColor(color);
		splashSprite.draw(batch);
		batch.end();
		
		super.render(delta);
	}
	
	@Override
	public void hide() {
		splashSprite.getTexture().dispose();
		super.hide();
	}

	@Override
	public void preAssetLoad() {
	}

	@Override
	public void postAssetLoad() {
	}
	
	@Override
	public void resize(int width, int height) {
		super.resize(width, height);
	}
	
	@Override
	public Screen createMainScreen(RhythmBullet game) {
		return new MainScreen(game);
	}
}
